package account

import (
	"net/http"
	"nos-comptes/handler"
	"nos-comptes/internal/storage/dao/postgresql"
	"nos-comptes/internal/storage/model"
	"nos-comptes/internal/storage/validators"
	"nos-comptes/internal/user"
	"nos-comptes/internal/utils"
	utils2 "nos-comptes/internal/utils"

	"github.com/gin-gonic/gin"
)

type Context struct {
	service     *Service
	db          *Database
	userService *user.Service
	*handler.Context
}

func (c *Context) GetAllAccountOfUser(gc *gin.Context) {
	userId := gc.Param("userId")
	err := c.Validator.VarCtx(gc, userId, "uuid4")
	if err != nil {
		utils2.JSONError(gc.Writer, validators.NewDataValidationAPIError(err))
		return
	}

	_, err = c.userService.GetUserById(userId)
	if e, ok := err.(*model.APIError); ok {
		utils.GetLoggerFromCtx(gc).WithError(err).WithField("type", e.Type).Error("error GetUser: get user error")
		utils.JSONErrorWithMessage(gc.Writer, *e, e.Description)
	} else if err != nil {
		utils.GetLoggerFromCtx(gc).WithError(err).Error("error while get user")
		utils.JSONError(gc.Writer, model.ErrInternalServer)
		return
	}

	accounts, err := c.service.GetAllAccountOfUser(userId)
	if e, ok := err.(*model.APIError); ok {
		utils.GetLoggerFromCtx(gc).WithError(err).WithField("type", e.Type).Error("error GetAllAccounts: get accounts")
		utils.JSONErrorWithMessage(gc.Writer, *e, e.Description)
	} else if err != nil {
		utils.GetLoggerFromCtx(gc).WithError(err).Error("error while get accounts")
		utils.JSONError(gc.Writer, model.ErrInternalServer)
		return
	}

	if len(accounts) == 0 {
		utils.JSON(gc.Writer, http.StatusNoContent, nil)
	} else {
		utils.JSON(gc.Writer, http.StatusOK, accounts)
	}

}

func (c *Context) CreateAccountOfUser(context *gin.Context) {

}

func (c *Context) DeleteAccountOfUser(context *gin.Context) {

}

func (c *Context) GetSpecificAccountOfUser(context *gin.Context) {

}

func NewHandler(ctx *handler.Context, db *postgresql.DatabasePostgreSQL) *Context {
	database := NewDatabase(db)
	service := NewService(database)
	userService := user.NewService(user.NewDatabase(db))
	return &Context{service: service, db: database, userService: userService, Context: ctx}
}
